/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controllers;

import business.BasketStateful;
import domain.BasketItem;
import domain.Product;
import java.io.Serializable;
import java.security.Principal;
import java.util.ArrayList;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 *
 * @author hardebolle
 */
@ManagedBean(name = "basketController")
@SessionScoped
public class BasketController implements Serializable {

    @EJB
    private BasketStateful basket;

    public ArrayList<BasketItem> getItemList() {
        return this.basket.getItems();
    }

    public double getTotalPrice() {
        return this.basket.getTotalPrice();
    }

    public String addProductToBasket(Product p) {
        this.basket.addProduct(p);
        return "basket-view";
    }

    public String removeItemFromBasket(BasketItem i) {
        this.basket.removeItem(i);
        return "basket-view";
    }

    public String updateTotalPrice() {
        this.basket.updateTotalPrice();
        return "basket-view";
    }

    public String getUsername() {
        ExternalContext ctx = FacesContext.getCurrentInstance().getExternalContext();
        Principal p = ctx.getUserPrincipal();
        boolean roleOK = ctx.isUserInRole("admins");
        System.out.println("in role admins : "+roleOK);
        if (p != null) {
            System.out.println("in JSF : "+p.getName());
            return p.getName();
        }
        
        return "";
    }
}
